unit Cal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DateUtils, StdCtrls, ExtCtrls, Buttons;

type
  TCalForm = class(TForm)
    MCal: TMonthCalendar;
    ListBox1: TListBox;
    Timer1: TTimer;
    Filter: TEdit;
    Label1: TLabel;
    PrevDay: TButton;
    NextDay: TButton;
    HideCal: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure MCalClick(Sender: TObject);
    procedure MCalGetMonthInfo(Sender: TObject; Month: Cardinal;
      var MonthBoldInfo: Cardinal);
    procedure ListBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure HideCalClick(Sender: TObject);
    procedure FilterChange(Sender: TObject);
    procedure PrevDayClick(Sender: TObject);
    procedure NextDayClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CalForm: TCalForm;

implementation
uses Main;

{$R *.dfm}

var
  Nr:array[0..10000]of word;
  CurDate: TDate;

const
  Months:array[1..12]of string[3]=
    ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

function FnToDate(fn:string;out Date:TDate):boolean;
var s:string;i,j:integer;F:Text;
  Day,Month,Year:Integer;
begin
  Result:=True;
  s:=copy(fn,length(fn)-11,8);
  if (length(s)=8)and(TryStrToInt(s,j)) then
    begin
    Date:=EncodeDate(StrToInt(copy(s,1,4)),
                     StrToInt(copy(s,5,2)),
                     StrToInt(copy(s,7,2)));
    Exit
    end;
  Assign(f,fn);
  {$I-}reset(f);{$I+}
  if ioresult=0 then
    begin
    repeat
      readln(f,s)
    until s<>'';
    close(f);
    if copy(s,1,15)='Session Start: ' then
      begin
      Day:=0;Month:=0;Year:=0;
      for i:=1 to 12 do
        if Copy(s,20,3)=Months[i] then
          Month:=i;
      TryStrToInt(Copy(s,24,2),Day);
      TryStrToInt(Copy(s,36,4),Year);
      if(Day<>0)and(Month<>0)and(Year<>0)then
        begin
        Date:=EncodeDate(Year,Month,Day);
        Exit
        end;
      end;
    end;
  Result:=False;
end;

procedure ListDay(Day:TDate);
var i,sel:integer;s:string;D:TDate;
begin
  with CalForm do
    begin
    DateTimeToString(s, 'dddd, dddddd', Day);
    s[1]:=Upcase(s[1]);
    Caption:=s;

    ListBox1.Clear;
    sel:=-1;
    for i:=1 to LogNr do
      begin
      if (Filter.Text<>'')and(Pos(UpperCase(Filter.Text),UpperCase(Logs[i]))=0)then
        continue;
      if FnToDate(Logs[i],D)then
        if D=Day then
          begin
          ListBox1.Items.Add(ExtractFileName(Logs[i]));
          Nr[ListBox1.Items.Count-1]:=i;
          if i=CurLog then
            Sel:=ListBox1.Items.Count-1;
          end;
      end;
    if(ListBox1.Items.Count>0)and(Sel>=0)then
      begin
      ListBox1.ItemIndex:=Sel;
      ListBox1Click(nil);
      end;
    end;
end;

var
  First: boolean=true;
  UpdateCal: boolean;
procedure TCalForm.FormShow(Sender: TObject);
begin
  if First then
    begin
    MCal.AutoSize:=True;
    MCal.AutoSize:=False;
    MCal.Height:=437;
    MCal.Date:=Today;
    CurDate:=Today;
    HideCal.Caption:='>'#13#10'>'#13#10'>'#13#10'>'#13#10'>';
    end;
  First:=False;

  UpdateCal:=True;
  Timer1.Enabled:=True;
end;

procedure TCalForm.MCalClick(Sender: TObject);
begin
  CurDate:=MCal.Date;
  ListDay(CurDate);
end;

procedure TCalForm.MCalGetMonthInfo(Sender: TObject; Month: Cardinal;
  var MonthBoldInfo: Cardinal);
var i:integer;Mask:Cardinal;DT:TDate;
begin
  Mask:=0;
  for i:=1 to LogNr do
    begin
    if (Filter.Text<>'')and(Pos(UpperCase(Filter.Text),UpperCase(Logs[i]))=0)then
      continue;
    if FnToDate(Logs[i],DT) then
      begin
      if (YearOf(DT)=YearOf(MCal.Date))and(MonthOf(DT)=Month) then
        Mask:=Mask or (1 shl (DayOf(DT)-1));
      end;
    end;
  MonthBoldInfo:=Mask;
end;

procedure TCalForm.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex<>-1 then
    begin
    CurLog:=Nr[ListBox1.ItemIndex];
    Load(Logs[CurLog]);
    end;
end;

procedure TCalForm.Timer1Timer(Sender: TObject);
begin
  if UpdateCal then
    begin
    if (CurLog>0)and(FnToDate(Logs[CurLog],CurDate)) then
      begin
      MCal.Date:=CurDate;
      ListDay(CurDate);
//      MCalClick(nil);
      end;
    MCal.Refresh;
    UpdateCal:=False;
    end;
  Timer1.Enabled:=False;
end;

procedure TCalForm.HideCalClick(Sender: TObject);
begin
  LockWindowUpdate(Handle);
  if HideCal.Caption='>'#13#10'>'#13#10'>'#13#10'>'#13#10'>' then
    begin
    CalForm.Width:=CalForm.Width-MCal.Width;
    HideCal.Caption:='<'#13#10'<'#13#10'<'#13#10'<'#13#10'<';
    Left:=Left+MCal.Width;
    end
  else
    begin
    CalForm.Width:=CalForm.Width+MCal.Width;
    HideCal.Caption:='>'#13#10'>'#13#10'>'#13#10'>'#13#10'>';
    Left:=Left-MCal.Width;
    end;
  LockWindowUpdate(0);
end;

procedure TCalForm.FilterChange(Sender: TObject);
begin
  //MCal.Repaint;
  {LockWindowUpdate(MCal.Handle);
  MCal.Date:=EncodeDate(1980,1,1);
  MCal.Date:=CurDate;
  LockWindowUpdate(0);}
  ListDay(CurDate);
end;

procedure TCalForm.PrevDayClick(Sender: TObject);
var D,BestD:TDate;i:word;
begin
  BestD:=EncodeDate(1980,1,1);
  for i:=1 to LogNr do
    begin
    if (Filter.Text<>'')and(Pos(UpperCase(Filter.Text),UpperCase(Logs[i]))=0)then
      continue;
    if FnToDate(Logs[i],D) then
      begin
      if(BestD<D)and(D<CurDate)then
        BestD:=D;
      end;
    end;
  if BestD<>EncodeDate(1980,1,1) then
    begin
    CurDate:=BestD;
    MCal.Date:=CurDate;
    ListDay(CurDate);
    end;
end;

procedure TCalForm.NextDayClick(Sender: TObject);
var D,BestD:TDate;i:word;
begin
  BestD:=EncodeDate(3000,1,1);
  for i:=1 to LogNr do
    begin
    if (Filter.Text<>'')and(Pos(UpperCase(Filter.Text),UpperCase(Logs[i]))=0)then
      continue;
    if FnToDate(Logs[i],D) then
      begin
      if(BestD>D)and(D>CurDate)then
        BestD:=D;
      end;
    end;
  if BestD<>EncodeDate(3000,1,1) then
    begin
    CurDate:=BestD;
    MCal.Date:=CurDate;
    ListDay(CurDate);
    end;
end;

procedure TCalForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var B:Boolean;
begin
  B:=True;
  case Key of
    VK_LEFT:
      PrevDay.Click;
    VK_RIGHT:
      NextDay.Click;
    VK_ESCAPE:
      Close;
    else
      B:=False;
    end;
  if B then
    Key:=0;
end;

end.
