unit Main;

interface

uses
  Forms, StdCtrls, XPMan, Menus, Dialogs, Classes, Controls, ComCtrls,
  Windows, SysUtils, ReaderU2, AppEvnts, Cal;

type
  TMainForm = class(TForm)
    Log: TRichEdit;
    OpenDialog: TOpenDialog;
    StdCommands: TPopupMenu;
    XPManifest1: TXPManifest;
    MenuEditHgl: TMenuItem;
    Button3: TButton;
    FileName: TEdit;
    LoadButton: TButton;
    Button1: TButton;
    Button2: TButton;
    ApplicationEvents1: TApplicationEvents;
    StatusBar1: TStatusBar;
    Button4: TButton;
    MenuEditFldr: TMenuItem;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    MenuRescan: TMenuItem;
    procedure LoadButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PopupMenuChooseLog(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LogMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LogMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LogKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LogKeyPress(Sender: TObject; var Key: Char);
    procedure LogChange(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure MenuEditHglClick(Sender: TObject);
    procedure MenuEditFldrClick(Sender: TObject);
    procedure MenuRescanClick(Sender: TObject);
    procedure ProcessHotKeys(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LogKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure Load(fn:string);

var
  MainForm: TMainForm;

  LogNr,CurLog:word;
  Logs:array[1..10000]of string;


implementation

{$R *.dfm}

procedure Load(fn:string);
begin
  if MainForm.FileName.Text=fn then exit;
  MainForm.FileName.Text:=fn;
  TReader.Create(False);
end;

procedure LoadOther(fn:string);
var i:word;
begin
  Load(fn);
  CurLog:=0;
  for i:=1 to LogNr do
    if UpperCase(Logs[i])=UpperCase(fn) then
      CurLog:=i;
end;

procedure TMainForm.LoadButtonClick(Sender: TObject);
begin
if not OpenDialog.Execute then exit;
{FileName.Text:=OpenDialog.FileName;
TReader.Create(False);}
LoadOther(OpenDialog.FileName);
end;      

procedure ScanDir(Dir:string);
var t:TSearchRec;
begin
  if findfirst(Dir+'*.log',faAnyfile-faDirectory,t)=0 then
    begin
    repeat
      Inc(LogNr);
      Logs[LogNr]:=Dir+t.Name;
      if Logs[LogNr]=MainForm.FileName.Text then
        CurLog:=LogNr;
    until findnext(t)<>0;
    FindClose(t);
    end;
end;

procedure ScanLogs;
var s:string;f:text;
begin
  LogNr:=0;CurLog:=0;
  assignfile(f,ExtractFilePath(ParamStr(0))+'Dirs.txt');
  reset(f);
  while not eof(f) do
    begin
    ReadLn(f,s);
    if s='' then continue;
    if s[length(s)]<>'\' then
      s:=s+'\';
    if DirectoryExists(s) then
      ScanDir(s);
    end;
  Close(f);
  if (CurLog=0)and(LogNr>0) then
    CurLog:=1;
  if CurLog>0 then
    Load(Logs[CurLog]);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if CurLog>1 then
    begin
    Dec(CurLog);
    Load(Logs[CurLog]);
    end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if (CurLog<LogNr)and(CurLog>0) then
    begin
    Inc(CurLog);
    Load(Logs[CurLog]);
    end;
end;

procedure AddToMenu(Menu:TMenuItem;Caption,Hint:string;Event:TNotifyEvent);
var M:TMenuItem;
begin
  M:=TMenuItem.Create(Menu);
  M.Caption:=Caption;
  M.Hint:=Hint;
  M.OnClick:=Event;
  Menu.Add(M);
end;

procedure TMainForm.Button3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,j,k:integer;M,P,Cur:TMenuItem;T:TPoint;
Tree:array[1..100]of string;TreeNr:byte;
LogMenu:array[1..10000]of TMenuItem;s:string;
DT:TDateTime;
begin
  if Button<>mbLeft then exit;
  FillChar(LogMenu,SizeOf(LogMenu),0);
  PopupMenu1.Items.Clear;Cur:=nil;
  for i:=1 to LogNr do
    begin
    s:=ExtractFileName(Logs[i]);TreeNr:=0;
    while pos('.',s)<>0 do
      begin
      inc(TreeNr);
      Tree[TreeNr]:=copy(s,1,pos('.',s)-1);
      s:=copy(s,pos('.',s)+1,1000);
      while (pos('.',s)<>0)and(pos('.',s)<=3)do
        begin
        Tree[TreeNr]:=Tree[TreeNr]+'.'+copy(s,1,pos('.',s)-1);
        s:=copy(s,pos('.',s)+1,1000);
        end;
      end;
    {if TreeNr=0 then
      begin CurLog:=CurLog+1-1;Continue;end;}
    if(TreeNr>=2)and not((Length(Tree[2])=8)and(TryStrToInt(Tree[2],j)))then
      begin
      s:=Tree[1];
      Tree[1]:=Tree[2];
      Tree[2]:=s;
      end;
    P:=PopupMenu1.Items;
    for j:=1 to TreeNr do
      begin
      M:=P.Find(Tree[j]);
      if (M=nil)or(j=TreeNr) then
        begin
        M:=TMenuItem.Create(P);
        M.Caption:=Tree[j];
        if j=TreeNr then
          begin
          M.Tag:=i;
          M.OnClick:=PopupMenuChooseLog;
          M.Hint:=ExtractFileName(Logs[i]);
          if i=CurLog then
            Cur:=M;
          LogMenu[i]:=M;
          end;
        for k:=0 to P.Count do
          if (k=P.Count)or(UpperCase(P.Items[k].Caption)>UpperCase(Tree[j])) then
            begin
            P.Insert(k,M);
            break
            end;
        end;
      P:=M;
      end;
    end;
  if Cur<>nil then
    begin
    M:=Cur;
    repeat
      M.RadioItem:=True;
      M.Checked:=True;
//      M.GroupIndex:=j;
      M:=M.Parent;
    until M=PopupMenu1.Items;
    end;
  for i:=1 to LogNr do
    begin
    {if LogMenu[i]=nil then
      begin CurLog:=CurLog+1-1;Continue;end;}
    s:=LogMenu[i].Caption;
    if (length(s)=8)and(TryStrToInt(s,j))then
      begin
      DT:=EncodeDate(StrToInt(copy(s,1,4)),StrToInt(copy(s,5,2)),StrToInt(copy(s,7,2)));
      DateTimeToString(s, LongDateFormat, DT);
      LogMenu[i].Caption:=s;
      end;
    end;
  AddToMenu(PopupMenu1.Items,'-','',nil);
  AddToMenu(PopupMenu1.Items,'Rescan folders','Rescan folders for new logs',MenuRescanClick);
  AddToMenu(PopupMenu1.Items,'-','',nil);
  AddToMenu(PopupMenu1.Items,'Edit highlight list','Edit the list of high-lighted keywords',MenuEditHglClick);
  AddToMenu(PopupMenu1.Items,'Edit folder list','Edit the list of directories where LogReader should look for logs',MenuEditFldrClick);
  T:=Button3.ClientToScreen(Point(0,Button3.Height));
  PopupMenu1.Popup(T.X,T.Y);
end;

procedure TMainForm.PopupMenuChooseLog(Sender: TObject);
begin
  with Sender as TComponent do
    CurLog:=Tag;
  Load(Logs[CurLog]);
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  LoadHgl;
  ScanLogs;
  if ParamStr(1)<>'' then
    LoadOther(ParamStr(1));
end;

procedure UpdatePanel;
begin
  with MainForm do
    begin
    StatusBar1.Panels[0].Text:='Row: '+IntToStr(Log.CaretPos.Y);
    StatusBar1.Panels[1].Text:='Col: '+IntToStr(Log.CaretPos.X);
    Application.ProcessMessages;
    end;
end;

procedure TMainForm.LogMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);begin UpdatePanel end;
procedure TMainForm.LogMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);begin UpdatePanel end;
procedure TMainForm.LogKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);begin UpdatePanel;ProcessHotKeys(Sender,Key,Shift) end;
procedure TMainForm.LogKeyUp(Sender: TObject; var Key: Word;Shift: TShiftState);begin UpdatePanel end;
procedure TMainForm.LogKeyPress(Sender: TObject; var Key: Char);begin UpdatePanel end;
procedure TMainForm.LogChange(Sender: TObject);begin UpdatePanel end;

procedure TMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
  {if Application.Hint='' then
    StatusBar1.SimplePanel:=False
  else
    begin
    StatusBar1.SimplePanel:=True;
    StatusBar1.SimpleText:=Application.Hint;
    end;}
  StatusBar1.Panels[2].Text:=Application.Hint;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  CalForm.Show;
  CalForm.FormShow(nil);
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  Button3MouseDown(nil,mbLeft,[],0,0);
end;

procedure TMainForm.MenuEditHglClick(Sender: TObject);
begin
  WinExec(PChar('notepad.exe "'+ExtractFilePath(ParamStr(0))+'Hgl.txt"'),SW_SHOWNORMAL);
end;

procedure TMainForm.MenuEditFldrClick(Sender: TObject);
begin
  WinExec(PChar('notepad.exe "'+ExtractFilePath(ParamStr(0))+'Dirs.txt"'),SW_SHOWNORMAL);
end;

procedure TMainForm.MenuRescanClick(Sender: TObject);
begin
  LoadHgl;
  ScanLogs;
end;

procedure TMainForm.ProcessHotKeys(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var B:Boolean;
begin
  B:=True;
  case Key of
    VK_F1:
      Button3.Click;
    VK_F2:
      Button4.Click;
    VK_F3:
      LoadButton.Click;
    VK_SUBTRACT:
      Button1.Click;
    VK_ADD:
      Button2.Click;
    else
      B:=False;
    end;
  if B then
    Key:=0;
end;


end.
